#include <stdlib.h>
#include <assert.h>

#include "context.h"
#include "pqueue.h"

context * context_create(){
	context * ctx;
	ctx = malloc(sizeof(context));
	assert(ctx);
	ctx->nNodes=0;		// fill in with read_config
	ctx->nodes=NULL;	// fill in with read_config

	ctx->tsState=100;
	ctx->statePerNode=10;
	ctx->seed=0;
	ctx->pq= pqueue_create(1024);
	ctx->maxTransactionsRule=0;
	ctx->configFileName[0]=0;
	ctx->logfile=stdout;
	ctx->statfile=stdout;
	ctx->useLogFile=0;
	ctx->maxbad=4;
	ctx->nRounds=1;
	ctx->curRound=0;
	ctx->nSatisfied=0;
	ctx->nFailed=0;
	ctx->nFailedJobs=0;
	ctx->jobsDropped=0;
	ctx->cookieProtocol=0;
	ctx->MaxQueryHopCount=5;
	ctx->CookieSearchExpansionFactor=5;
	ctx->totJobs=0;
	ctx->stopAt=-1;
	ctx->charity=0;
	ctx->endAt=250;
	ctx->backoffProb=0.0;
	ctx->maxQueries=10;
	ctx->failTime=30.0;
	ctx->doneCount=0;
	ctx->totGood=0;	// fill in later
	return ctx;
}	

