#ifndef EVENT_H
#define EVENT_H

struct event;
#include "context.h"

typedef void (*eventfunct)(struct context *,struct event *, double );

typedef struct event {
	eventfunct fun;
	int src_id;
	int id;
	double t;
	void * arg;
} event;

void event_free(event *);
int event_create(struct context *,eventfunct, int src_id, int id, void * arg, double t);

#endif
