#ifndef PQUEUE_H
#define PQUEUE_H


typedef struct qelm {
	double key;
	void * data;
} qelm;

typedef struct pqueue {
	qelm * array;
	int length;
	int size;
}pqueue;

pqueue * pqueue_create(int initSize);
void pqueue_insert(pqueue*,void * data,double key);
void * pqueue_extract(pqueue *, double * key);
int pqueue_isempty(pqueue *);
void pqueue_unit_test();

#endif
